/*
 * Name: Date Picker with Enabled Dates
 * Developer: Isaac Meisner
 * Date: 08/18/2022
 */
define(function () {

    var install = function (holderElement, context) {
        
        // This gets the cell the widget is attached to
        var cell = context.getCell();
        //console.log(cell);
        var row = context.getRow();
        //console.log(row);
        
        // Access the DOM after the view.html has been created
        var textContainer = holderElement.querySelector(".widget-template-output-text");
        
        var selectedDateString = context.getParameter("SelectedDateString");
        var defaultViewDate = context.getParameter("MinAvailableDate");
        var datesToEnableString = context.getParameter("DatesToEnable");
        var datesToEnable = datesToEnableString.split(" ");
    
        $(function () {
            let enabledDates = datesToEnable;
            $('#datepicker').datepicker({
                format: 'mm/dd/yyyy',
                defaultViewDate: defaultViewDate,
                autoclose: true,
                beforeShowDay: function (date) {
                    let monthPadded = String("00" + (date.getMonth() + 1)).slice(-2);
                    let dayPadded = String("00" + date.getDate()).slice(-2);
                    let fullDate = monthPadded + '/' + dayPadded + '/' + date.getFullYear();
                    return enabledDates.indexOf(fullDate) != -1
                }
            });

            console.log("Initial Cell Value: " + selectedDateString);
            
            $('#datepicker').datepicker('setDate', selectedDateString);
            
            $('#datepicker').on('change', function() {
                var checkedValue = $('#datepicker').val();
                console.log("Checked Value: " + checkedValue);
                if (checkedValue === '') checkedValue = null;
                cell.value = checkedValue;
                row.save();
                console.log("New Value: " + cell.value);
            });
        });
    };

    var uninstall = function(holderElement, context) {
        // Nothing to do.
    };

    return {
        callbacks: {
            events: {
                // adding and removing
                install: install,
                uninstall: uninstall
            }
        }
    };
});
